#ifndef ANSI2OMNET_H
#define ANSI2OMNET_H

using namespace std;

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <queue>

#include <libxml2/libxml/xmlmemory.h>
#include <libxml2/libxml/parser.h>


struct Parameter{

  int xsize;
  int ysize;
  int extension_factor;
  double range;
  int numberOfNodes;

  double max_velocity;
  double max_stopTime;
  double max_moveTime;

  char* area_shape;
  char* mobility_model;
  char* communication_mode;
/*   communication communication_mode; */
/*   shape area_shape; */
/*   model mobility_model; */
};

struct Position {
  double xpos;
  double ypos;
};

struct PositionChange {
  double start_time;
  Position destination;
  double velocity;
};

struct Node {

  int node_id;
  Position position;
  queue<PositionChange> mobility;
};


class ANSim2omnet {

 private:
  xmlDocPtr doc;
  xmlNsPtr ns;
  xmlNodePtr cur;

  Parameter parameter;
  Node* nodeList;

  // lenght of simulation
  double stopTime;

  // Used to assign a unique id to each node
  int countID;

  Parameter parseParameter(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
  Node* parseNodeSettings (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur, int numberOfNodes);
  void parseMobility(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);

 public:
  ANSim2omnet() { }
  void parseXMLFile(const char *filename);
  Parameter getParameter() { return parameter; }
  Node* getNodeList() { return nodeList; }
  int getCountID() { return countID++; }
  double getStopTime() { return stopTime; }

  ~ANSim2omnet();
  
};

#endif
