//#include "omnetpp.h"
#include <cstatistic.h>
#include <coutvector.h>
#include "definitions.h"

#define MAX_NUMBER_OF_MSG 10000
class DataCollector: public cSimpleModule {


private:

	int m_iNumberOfHosts;
	int m_iNumberOfMessages;

	int m_iNumberOfBlackholeCarriers;
	int m_iNumberOfCarriers;

	cOutVector m_NumberOfAttractedMsg;
	cOutVector m_NumberOfDeliveredMsg;
	cOutVector m_NumberOfSentMsg;
	int m_iCollectTimer;

public:

	int m_iNumberOfMessagesReceived;
	int m_iNumberOfGoodMessagesReceived;
	int m_iNumberOfAckReceived;
	int m_iNumberOfBlackholeMessages;
	int m_iNumberOfGoodMessages;
	int m_iNumberOfAsyncMessagesReceived;
	int m_iNumberOfAttractedMessages;
	int m_iNumberOfForwardedMessages;
	int m_iNumberOfPenalizedMessages;
	int m_iNumberOfAsyncMessagesSent;	
	int m_iNumberOfBadMessagesReceived;

	int m_iTotalNumberOfSyncMessagesSent;
	int m_iTotalNumberOfAsyncMessagesSent;
	int m_iTotalNumberOfRoutingMessagesSent;
	double m_dPartialDelay;
	bool m_bMsgIdBuffer[MAX_NUMBER_OF_MSG];

	virtual void initialize();
	virtual void finish();
	virtual void vIncrementNumberOfMessagesReceived(int iHostId, double dDelay);
	virtual void vIncrementNumberOfMessageAttracted(int iMsgId);
	void handleMessage(cMessage *msg);
};
