#ifndef _DEFS_H
#define _DEFS_H

// Message Types
enum
{
	AUTO_MSG = 0,
	PROTOCOL_MSG = 1,
	CONTROL_MSG = 2,
	INFO_MSG = 3,
	CRC_UPDATE_MSG = 4,
	KALMAN_FILTER_AND_COLOCATION_UPDATE_MSG = 5,
	INFO_AND_ROUTING_TABLE_EXCHANGE_MSG = 6,
	LOCAL_BUFFER_FLUSH_MSG = 7,
	ACK_MSG = 8,
	// periodical decrement of reputation table's entries
	TIMEOUT_REPUTATION_TABLE = 9,
	ROUTING_TABLE_DBG = 10,
	RECONFIGURATION,
	COLLECT_REPUTATION = 11,
	COLLECT_MSG = 12
};

// time to wait before starting send data messages
// this is approximately the convergence time of DSDV (the underlying synch. protocol)
const double initialWaitTime = 300.0;

// transmission range of each node
// it was 50
const double radius = 25.0;

// interval between the creation of messages (module simController)
//const double messageCreationInterval = 0.7;


enum nodeType
{
	NORMAL = 0,
	ACTIVE_NON_COLLABORATIVE = 1,
	PASSIVE_NON_COLLABORATIVE = 2
};

// number of groups
const int numberOfGroups = 4;

enum dataCollectorMsgType
{
	DC_NORMAL_MSG = 0,
	DC_ACK_MSG = 1,
	DC_MSGBUNDLE_COLLECT = 2,
	DC_COLLECT_REPUTATION = 3
};

const int MAX_NUM_HOSTS = 150;
const int MAX_HISTORY_TABLE_SIZE = 150;
const int BUFFER_SIZE = 10000;
const int MAX_RTT_NUMBER = 100;
const int initialMsgBundle = 200;

enum routingProtocol
{
	CAR = 0,
	RCAR = 1,
};

#endif
