#ifndef ENGINE
#define ENGINE
#include "omnetpp.h"
#include "ANSim2omnet.h"
#include "definitions.h"
class Engine: public cSimpleModule {
	
	protected:
		double range;
		Node* nodeList;
		Parameter scenario;
		Position positions[MAX_NUM_HOSTS];
		int numHosts;
		bool isConnected[MAX_NUM_HOSTS][MAX_NUM_HOSTS];
	
	public:
	
		struct hostItem {
			int currentX;
			int currentY;
		};
	
		hostItem hosts[MAX_NUM_HOSTS];
		
		virtual void initialize();
		virtual void handleMessage(cMessage *msg);
		virtual void initPositions();
		virtual void updatePositions();
		virtual double getNextMoveTime(int nodeId);
	

};
#endif
