#define NUMBER_OF_SAMPLES 55
#define K_MAX 30

class KalmanPredictor {
	
	
	public:
	
	//autocorrelation variables
	int totalnumberOfSamples;
	
	//pointer to the current position of the residuals array
	int pointer;
	
	//maximum acceptable Average Percentage Forecasting Error.
	double APFE;
	
	//private enable logging
	bool logging;
	
    double samples[NUMBER_OF_SAMPLES];
	
	//residuals used in the calculation of the autocorrelation coefficients
	double residuals[NUMBER_OF_SAMPLES];
	
	//average percentage error used in the calculation of the forecasting error 
	double pError[NUMBER_OF_SAMPLES];
	
	//autocorrelation coefficients
	double r[K_MAX];

	double xPred1;
	
	int counter;
	
	double currentPredictedValue;
	
	double currentValue;
	
	double currentInputValue;
	
	double INITIAL_PREDICTED_VALUE;

	double pastPredictedValue;
	
	double currentOmegat;

	double qt;
	
	double rt;
	
	double numberOfValidSamples;
	
	double numberOfPredictableSamples;
	
	double outliersThreshold;
	KalmanPredictor();
	KalmanPredictor(double dInitialPredictedValue);

	void init();
	virtual void reset();
	
	virtual double getPredictedValue(double currentValue);
	
	virtual bool isPredictable();
	
	virtual double getPredictability();
};
